=== debian/changelog ===
arm-trusted-firmware (2.0+290.98aab974-2) unstable; urgency=medium

  * Upload to unstable.

 -- Vagrant Cascadian <vagrant@debian.org>  Tue, 27 Nov 2018 15:33:29 -0800

arm-trusted-firmware (2.0+290.98aab974-1) experimental; urgency=medium

  * Upstream git snapshot from commit 98aab97484b27e40aa74a93e5d1c1ac037a7e0b8.
    - Fixes for USB and Ethernet on allwinner platforms.
  * Enable gxbb (tested on Odroid-C2).

 -- Vagrant Cascadian <vagrant@debian.org>  Mon, 26 Nov 2018 23:41:28 -0800

arm-trusted-firmware (2.0+267~cabe0a31-1) experimental; urgency=medium

  * Upstream git snapshot from commit cabe0a31801e99e7abb84d2114ded6bb56f3c71e.
  * Initial upload to Debian (Closes: #881620).

 -- Vagrant Cascadian <vagrant@debian.org>  Mon, 19 Nov 2018 14:25:59 -0800
