=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v\.tar\.gz/@PACKAGE@-$1\.tar\.gz/,uversionmangle=s/-rc/~rc/g \
   https://github.com/ARM-software/@PACKAGE@/tags .*/v@ANY_VERSION@.tar.gz
