=== debian/control ===
Source: arm-trusted-firmware
Section: admin
Priority: optional
Maintainer: Vagrant Cascadian <vagrant@debian.org>
Standards-Version: 4.2.1
Build-Depends: debhelper-compat (= 11),
Rules-Requires-Root: no
Homepage: https://github.com/ARM-software/arm-trusted-firmware
Vcs-Browser: https://salsa.debian.org/debian/arm-trusted-firmware
Vcs-Git: https://salsa.debian.org/debian/arm-trusted-firmware.git -b debian/master

Package: arm-trusted-firmware
Architecture: arm64
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: u-boot-sunxi
Description: "secure world" software for ARM SoCs
 The "secure world" on arm64 machines is a special level of CPU
 privilege that is hidden from the normal OS, and has complete
 control over the system.  It provides both initialization during
 early boot stages (before u-boot or EFI) and system monitor
 functionality once the machine is booted up.  This is an equivalent
 of Intel ME on x86.
