=== debian/changelog ===
arm-trusted-firmware (2.1-3) unstable; urgency=medium

  * Update URLs for move to trustedfirmware.org.
  * debian/control: Update to Standards-Version 4.4.0.

 -- Vagrant Cascadian <vagrant@debian.org>  Mon, 08 Jul 2019 10:25:12 -0700

arm-trusted-firmware (2.1-2) experimental; urgency=medium

  * Build rk3328 bl31.elf.
  * Drop Recommends on u-boot-sunxi.

 -- Vagrant Cascadian <vagrant@debian.org>  Mon, 13 May 2019 16:23:51 -0700

arm-trusted-firmware (2.1-1) experimental; urgency=medium

  * New upstream version.
  * debian/control:
    - Update Standards-Version to 4.3.0, no changes needed.
    - Switch to debhelper-compat 12.

 -- Vagrant Cascadian <vagrant@debian.org>  Wed, 10 Apr 2019 01:02:30 -0700
