=== debian/changelog ===
arm-trusted-firmware (2.2-2) unstable; urgency=medium

  * Upload to unstable.

 -- Vagrant Cascadian <vagrant@debian.org>  Wed, 08 Jan 2020 00:24:14 -0800

arm-trusted-firmware (2.2-1) experimental; urgency=medium

  * New upstream version.
  * debian/copyright: Updates for v2.2.
  * debian/control: Update Standards-Version to 4.4.1, no changes needed.
  * debian/control: Add Breaks on u-boot-rockchip less than 2020.01~rc5.

 -- Vagrant Cascadian <vagrant@debian.org>  Wed, 25 Dec 2019 18:46:10 -0800
