=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: admin
 Priority: optional
 Maintainer: Vagrant Cascadian <vagrant@debian.org>
-Standards-Version: 4.4.0
+Standards-Version: 4.4.1
 Build-Depends: debhelper-compat (= 12),
 Rules-Requires-Root: no
 Homepage: https://www.trustedfirmware.org/
@@ -12,6 +12,7 @@
 Package: arm-trusted-firmware
 Architecture: arm64
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Breaks: u-boot-rockchip (<< 2020.01~rc5)
 Description: "secure world" software for ARM SoCs
  The "secure world" on arm64 machines is a special level of CPU
  privilege that is hidden from the normal OS, and has complete
