=== debian/watch ===
version=4
opts=filenamemangle=s/.*trusted-firmware-a-(.*)/@PACKAGE@-$1/,uversionmangle=s/-rc/~rc/g \
  https://git.trustedfirmware.org/TF-A/trusted-firmware-a.git/ .*/trusted-firmware-a-@ANY_VERSION@.tar.gz
