## arm-trusted-firmware 2.3+dfsg

=== debian/changelog ===
arm-trusted-firmware (2.3+dfsg-1) unstable; urgency=medium

  * Remove binary files with unknown licensing (Closes: #961697).
  * Update debian/copyright.
  * Update debian/watch.

 -- Vagrant Cascadian <vagrant@debian.org>  Wed, 08 Jul 2020 08:26:49 -0700

arm-trusted-firmware (2.3-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright: Update for new upstream version.
  * debian/upstream: Add upstream signing key.

 -- Vagrant Cascadian <vagrant@debian.org>  Sun, 26 Apr 2020 10:34:37 -0700

arm-trusted-firmware (2.2-3) unstable; urgency=medium

  [ Vagrant Cascadian ]
  * debian/control:
    - Add build-deps for rk3399.
    - Update Standards-Version to 4.5.0, no changes.
  * Enable rk3399 target.
  * Add lintian override for rk3399.

  [ Walter Lozano ]
  * Fix build for rk3399 (Closes: #956298)

 -- Vagrant Cascadian <vagrant@debian.org>  Fri, 10 Apr 2020 08:34:34 -0700
